package asd.td2;

import asd.base.ObjetAClef;

/**
 * Une classe pour l'exercice 1 de la feuille 2.
 * @author  2003 Marc Gatano
 */
public class Recherche {

    private ObjetAClef[] T; // le tableau 

    /**
     * Construit un objet Recherche pour rechercher des
     * lments dans le tableau T.
     * Complexit : THETA(1).
     */
    public Recherche(ObjetAClef[] T) {
        this.T = T;
    }

    /**
     * Recherche par trichotomie une occurence arbitraire
     * de clef k dans le tableau.
     * Prcondition : le tableau est tri par ordre croissant
     * des clefs.
     * Valeur rendue : une occurence arbitraire de clef k
     * dans le tableau s'il elle existe, null sinon.
     * Complexit : O(lg(n)) o n = la taille du tableau.
     */
    public ObjetAClef chercher(int k) {

        int g = 0;
        int d = T.length - 1;

        // INVARIANT :
        // les occurences de clef k de T sont dans T[g..d]
        // VARIANT :
        // d - g dcroit et est minor par 0
        //
        while ( g <= d ) {

            int mg = (2*g + d + 1)/3;
            int md = (g + 2*d + 2)/3;

            if ( k < T[mg].clef() ) {
                d = mg - 1;
            }
            else {
                if ( k == T[mg].clef() ) {
                    return T[mg];
                }
                if ( k < T[md].clef() ) {
                    g = mg + 1;
                    d = md - 1;
                }
                else {
                    if ( k == T[md].clef() ) {
                        return T[md];
                    }
                    g = md + 1;
                }
            }
        }
        // CONSQUENT :
        // les occurences de clef k de T sont dans T[g..d] et
        // T[g..d] est vide (car g > d) ==> il n'y a aucun objet
        // de clef k dans T 
        return null;
    }
}
